clang 8.0.0

Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
clang::ento::SymbolData Class Reference

A symbol representing data which can be stored in a memory location (region). More...

`#include "clang/StaticAnalyzer/Core/PathSensitive/SymExpr.h"`

Inheritance diagram for clang::ento::SymbolData:
[legend]
Collaboration diagram for clang::ento::SymbolData:
[legend]

## Public Member Functions
| ~SymbolData () override=default
SymbolID | getSymbolID () const
unsigned | computeComplexity () const override
Public Member Functions inherited from clang::ento::SymExpr
virtual | ~SymExpr ()=default
Kind | getKind () const
virtual void | dump () const
virtual void | dumpToStream (raw_ostream &os) const
virtual QualType | getType () const =0
virtual void | Profile (llvm::FoldingSetNodeID &profile)=0
symbol_iterator | symbol_begin () const
virtual const MemRegion * | getOriginRegion () const
| Find the region from which this symbol originates. More...

## Static Public Member Functions
static bool | classof (const SymExpr *SE)
Static Public Member Functions inherited from clang::ento::SymExpr
static symbol_iterator | symbol_end ()

## Protected Member Functions
| SymbolData (Kind k, SymbolID sym)
Protected Member Functions inherited from clang::ento::SymExpr
| SymExpr (Kind k)

## Additional Inherited Members
Public Types inherited from clang::ento::SymExpr
enum | Kind
Static Protected Member Functions inherited from clang::ento::SymExpr
static bool | isValidTypeForSymbol (QualType T)
Protected Attributes inherited from clang::ento::SymExpr
unsigned | Complexity = 0

## Detailed Description

A symbol representing data which can be stored in a memory location (region).

Definition at line 117 of file SymExpr.h.

## Constructor & Destructor Documentation

## ◆ SymbolData()

clang::ento::SymbolData::SymbolData | ( | Kind | k,
|  | SymbolID | sym
| ) |  |
| inline protected

Definition at line 123 of file SymExpr.h.

References clang::classof().

## ◆ ~SymbolData()

clang::ento::SymbolData::~SymbolData | ( |  | ) |
| override default

## Member Function Documentation

## ◆ classof()

static bool clang::ento::SymbolData::classof | ( | const SymExpr * | SE | ) |
| inline static

Definition at line 137 of file SymExpr.h.

References clang::ento::SymExpr::getKind().

## ◆ computeComplexity()

unsigned clang::ento::SymbolData::computeComplexity | ( |  | ) | const
| inline override virtual

Implements clang::ento::SymExpr.

Definition at line 132 of file SymExpr.h.

## ◆ getSymbolID()

SymbolID clang::ento::SymbolData::getSymbolID | ( |  | ) | const
| inline

Definition at line 130 of file SymExpr.h.

The documentation for this class was generated from the following files:

- include/clang/StaticAnalyzer/Core/PathSensitive/SymExpr.h
- lib/StaticAnalyzer/Core/SymbolManager.cpp